-- Author:Miodowy
-- Name:HorseCareManage

HorseCareManager = {}
HorseCareManager.costFactor = 2

function HorseCareManager:adjustHourlyBehavior(originalCallback)
    return function(instance, ...)
        originalCallback(instance, ...)

        local currentHour = g_currentMission.environment.currentHour
        if currentHour == 23 and instance.typeName == "horseHusbandry" then
            local upkeepCost = 0
            local horseClusters = instance:getClusterSystem().clusters
            
            for _, horse in pairs(horseClusters) do
                local ridingDeficit = (100 - horse.riding) * HorseCareManager.costFactor
                local fitnessDeficit = (100 - horse.fitness) * HorseCareManager.costFactor
                local dirtCost = horse.dirt * HorseCareManager.costFactor
                
                upkeepCost = upkeepCost + ridingDeficit + fitnessDeficit + dirtCost

                horse.riding = 100
                horse.fitness = 100
                horse.dirt = 0
            end

            if g_server and upkeepCost > 0 then
                local dailyCost = upkeepCost / g_currentMission.environment.daysPerPeriod
                g_currentMission:addMoney(-dailyCost, instance.ownerFarmId, MoneyType.ANIMAL_UPKEEP, true, true)
            end
        end
    end
end

PlaceableHusbandry.onHourChanged = HorseCareManager:adjustHourlyBehavior(PlaceableHusbandry.onHourChanged)


